Status: New Start date: 11 Feb 2014

Priority: High Due date:  

Assignee: John Abbott % Done: 0%

Category: New Function Estimated time: 0.00 hour

Target version: CoCoALib-1.0 Spent time: 0.55 hour

Description

Port the RealRoots code to C++ so that it is accessible to CoCoALib users!

I hope that a well-written port might gain as much as a factor of 2 in speed :-)

Related issues:

Related to CoCoA-5 - Support #242: CoCoA-5 Projects for students (e.g. credit... In Progress 28 Sep 2012

Related to CoCoALib - Feature #974: QIR/RealRootRefine: improve behaviour if ... In Progress 17 Nov 2016

History

#1 - 11 Feb 2014 20:10 - John Abbott

- Category set to New Function

Make the code prefer "binary rationals" as much as possible; exploit this fact when evaluating the polynomial.  In any case, avoid rational arithmetic

as much as possible.  Investigate the idea of a "target denominator" (what does this mean if the interval is wider than 4, say?)

In a cascade of failures we can evaluate just one point at each stage of the cascade (until the last one, of course) since we know what sign one end

of the subinterval must have.

Add some tracing info: I'm thinking of a list of log(log(N)) at each iteration; it'll cost nothing and maybe quite useful to people studying the algorithm.

#2 - 02 Apr 2014 09:16 - Anna Maria Bigatti

- Target version set to CoCoALib-0.99533 Easter14

#3 - 04 Apr 2014 17:17 - John Abbott

- Target version changed from CoCoALib-0.99533 Easter14 to CoCoALib-1.0

#4 - 21 Nov 2015 15:09 - John Abbott

After the SC^2 meeting it is clear that several people would like RealRoots to be ported into C++.  If the project is funded, it will probably start in June

2016; so perhaps the porting can be done as part of that project (and in its early stages).

#5 - 19 Oct 2016 10:26 - John Abbott

- Assignee set to John Abbott

- Priority changed from Normal to High

Some of Erika's people would like this to be in CoCoALib sooner rather than later!

#6 - 17 Nov 2016 19:16 - John Abbott

- Related to Feature #974: QIR/RealRootRefine: improve behaviour if input interval has "nasty" endpoints added
